#!/usr/bin/env lua
-- LunoSwan2 1.0-1704: chương trình nhập liệu cho mô hình Swan 41.10 (2 chiều)  

------ Bắt đầu phần sửa số liệu ------
-- Lưu ý: không dịch chuyển các dòng số liệu này để tiện tra cứu 
-- Tên các file kịch bản, số liệu, kết quả 
fileswn = 'phuquy'				-- tên file dự án (KHÔNG ghi .swn) 
filebot = 'phuquy.bot'			-- tên file địa hình đáy 
filespecout = 'spect-PQ-tho.txt'		-- tên file phổ kết quả 
filetableout = 'table-PQ-tho.txt'		-- tên file bảng số liệu kết quả 
fileblockout = 'block-PQ-tho.txt'		-- tên file bảng số liệu kết quả 

-- Địa hình (INPGRID BOT)
xpinp = 270109.61 				-- vị trí x điểm gốc số liệu địa hình 
ypinp = 1155946.57 						-- vị trí y điểm gốc số liệu địa hình 
alpinp = 0
mxinp =359						-- số đoạn chia địa hình theo trục x (số đoạn = số điểm địa hình - 1)
myinp =538						-- số đoạn chia địa hình theo trục y (số đoạn = số điểm địa hình - 1)
dxinp = 30						-- các điểm trên trục x cách đều nhau bao nhiêu m? 
dyinp = 30						-- các điểm trên trục y cách đều nhau bao nhiêu m? 

-- Lưới tính toán (CGRID)
xpc =  270109.61 						-- vị trí x điểm gốc lưới tính toán 
ypc = 1155946.57 						-- vị trí y điểm gốc lưới tính toán 
alpc = 0
xlenc = 10800.					-- chiều x của miền tính toán (m)
ylenc = 16170.					-- chiều x của miền tính toán (m)
mxc = 60               -- số ô lưới tính toán 
myc = 90				   -- số ô lưới tính toán 
mdc = 12						-- số múi quạt phổ 
flow = 0.05						-- tần số thấp trong phổ (Hz)
fhig = 1.0						-- tần số cao trong phổ (Hz)
msc = 23						-- số dải tần 

-- Điều kiện biên (BOUND)
optJONSWAP = true				-- dùng phổ JONSWAP cho biên?
optPM = false					-- dùng phổ PM cho biên?
gamma = 3.3						-- hệ số trong phổ JONSWAP
PEAKorMEAN = 'PEAK'				-- tính chu kì theo Tp hay Tm ?
POWERorDEGREE = 'POWER'			-- phân tán hướng theo số mũ hay góc độ?

optBOUND1 = true				-- có khai báo biên thứ nhất không?
bndside1 = 'N'					-- phía biên sóng (W=tây, E=đông, N=bắc, S=nam)
hs1 = 1.92						-- chiều cao sóng ý nghĩa (m) tại biên 
per1 = 6.07					-- chu kì sóng (s) tại biên 
dir1 = 56.25						-- hướng sóng tại biên 
dd1 = 2							-- số mũ hoặc độ lệch chuẩn phân tán hướng 

optBOUND2 = true				-- có khai báo biên thứ hai không?
bndside2 = 'E'					-- phía biên sóng (W=tây, E=đông, N=bắc, S=nam)
hs2 = 1.92						-- chiều cao sóng ý nghĩa (m) tại biên 
per2 = 6.07						-- chu kì sóng (s) tại biên 
dir2 = 56.25						-- hướng sóng tại biên 
dd2 = 2							-- số mũ hoặc độ lệch chuẩn phân tán hướng 

optBOUND3 = false				-- có khai báo biên thứ ba không?
bndside3 = 'S'					-- phía biên sóng (W=tây, E=đông, N=bắc, S=nam)
hs3 = 1.0						-- chiều cao sóng ý nghĩa (m) tại biên 
per3 = 5.0						-- chu kì sóng (s) tại biên 
dir3 = 56.25						-- hướng sóng tại biên 
dd3 = 2							-- số mũ hoặc độ lệch chuẩn phân tán hướng 

-- Điều kiện ban đầu (INIT)
optINITDEF = true				-- dùng điều kiện ban đầu mặc định?
optINITPAR = false				-- dùng điều kiện ban đầu là tham số?

-- Mực nước (SET LEVEL)
level = 0.221						-- mực nước 

-- Gió (WIND)
wvel =7						-- tốc độ gió (m/s)
wdir = 45						-- hướng gió (so với Bắc)

-- Bật/tắt các cơ chế (OFF)
optOFFWINDGR = false			-- tắt cơ chế tạo sóng từ gió?
optOFFWCAP = false				-- tắt cơ chế sóng bạc đầu?
optOFFBREAK = false				-- tắt cơ chế sóng vỡ?
optOFFQUAD = false				-- tắt cơ chế tương tác sóng quadruplet?
optOFFFSHIFT = false			-- tắt cơ chế chuyển tần số trong không gian tần?
optOFFBNDCHK = false			-- tắt cơ chế k.tra so giữa Hs tính - đặt tại biên?

-- Tạo sóng từ gió (GEN3)
optGEN3KOMEN = true				-- dùng công thức Komen?
optGEN3JANSSEN = false			-- dùng công thức Janssen?
cds1 = 4.5						-- hệ số quy định tốc độ tiêu tán sóng bạc đầu 
delta = 0.5						-- hệ số quy định sự ảnh hưởng sóng bạc đầu theo số sóng 
cds2 = 2.36E-5					-- hệ số quy định tốc độ tiêu tán năng lượng bạc đầu 
stpm = 3.02E-3 					-- độ dốc sóng trong phổ PM 
AGROWorNOT = 'AGROW'			-- có tính tăng trưởng sóng (Cavalieri & Malanotte 1981)? 
a = 0.0015						-- hệ số tỉ lệ tăng trưởng sóng Cavalieri ...

-- Sóng bạc đầu (WCAP)
powst = 2						-- số mũ độ dốc chuẩn hoá theo độ dốc sóng trong phổ PM 
powk = 1						-- số mũ của số sóng chuẩn hoá theo số sóng trung bình

-- Ma sát (FRIC)
optFRICJONSWAP = false			-- tính ma sát theo công thức JONSWAP?
optFRICCOLLINS = false			-- tính ma sát theo công thức Collins?
optFRICMADSEN = false 			-- tính ma sát theo công thức Madsen?
optFRICRIPPLE = true 			-- tính ma sát theo đặc trưng cát đáy?
cfjon = 0.038					-- hệ số trong công thức JONSWAP
cfw = 0.015						-- hệ số ma sát đáy Collins
kn = 0.05						-- độ gồ ghề đáy tương đương (m)
s = 2.65						-- dung trọng riêng hạt cát 
D = 0.00015						-- đường kính hạt cát (m)

-- Sóng vỡ (BREAK)
optBREAKCONST = true 			-- sóng vỡ với gamma không đổi?
optBREAKRUESSINK = false 		-- sóng vỡ theo công thức Ruessink 
optBREAKBKD = false 			-- sóng vỡ theo công thức độ dốc - chiều sâu k thứ nguyên  
alpha = 1.0						-- hệ số tỉ lệ tốc độ tiêu tán năng lượng 
gammab = 0.75					-- hệ số sóng vỡ không đổi 
aruessink = 0.76				-- hệ số tỉ lệ sóng vỡ Ruessink 
bruessink = 0.29				-- hệ số tăng/giảm sóng vỡ Ruessink 
gamma0 = 0.54					-- hệ số sóng vỡ tham chiếu đáy phẳng 
a1 = 7.59						-- hệ số hiệu chỉnh sóng vỡ thứ nhất 
a2 = -8.06						-- hệ số hiệu chỉnh sóng vỡ thứ hai  
a3 = 8.09						-- hệ số hiệu chỉnh sóng vỡ thứ ba 

-- Tương tác sóng (QUAD)
do
	iquad = 2						-- phương pháp tích phân quadruplet, 2=hiện, mỗi lần quét 
	lambda = 0.25					-- hệ số cấu hình quadruplet 
	cnl4 = 3E7						-- hệ số tỉ lệ tương tác quadruplet 
	csh1 = 5.5						-- hệ số nước nông thứ nhất 
	csh2 = 0.833333					-- hệ số nước nông thứ hai   
	csh3 = -1.25					-- hệ số nước nông thứ ba 
end

-- Tương tác sóng (TRIAD)
do 
	itriad = 1						-- phương pháp xấp xỉ triad (1=LTA, 2=SPB)
	trfac = 0.8						-- hệ số tỉ lệ (0.8 với LTA, 0.9 với SPB)
	cutfr = 2.5						-- tỉ số giữa fmax và f trung bình, cắt bỏ f cao hơn max 
	atriad = 0.95					-- hệ số thứ nhất hiệu chỉnh K trong PT Becq-Girard
	btriad = 0.0					-- hệ số thứ hai hiệu chỉnh K trong PT Becq-Girard
	urcrit = 0.2					-- số Ursell tới hạn 
	urslim = 0.01					-- ngưỡng dưới số Ursell 
end

-- Tính nước dềnh (SETUP)
optSETUP = true 				-- có tính nước dềnh không?
supcor = 0.00					-- độ cao nước dâng tại biên phía biển (m)

-- Yếu tố khác (VEGE, TURB, MUD, LIM)
do
	optVEGE = false					-- có tính đến thực vật không?
	optTURB = false					-- có tính đến rối động không?
	optMUD = false					-- có tính đến bùn không?
	optLIM = false					-- có quy định một số giới hạn không?
	height = 1.0					-- chiều cao cây (m)
	diamtr = 0.05					-- đường kính mỗi thân cây (m)
	nstems = 10						-- số thân cây trên 1 m^2
	drag = 0.02						-- hệ số cản
	ctb = 0.01						-- hệ số tỉ lệ trong tiêu tán năng lượng 
	CURRENTorNOT = 'CURRENT'		-- độ nhớt rối được tính từ vận tốc dòng chảy?
	tbcur = 0.004					-- hệ số * (U*h) để được độ nhớt rối 
	layer = 0.1						-- bề dày lớp bùn đáy (m)
	rhom = 1300						-- dung trọng lớp bùn (kg/m^3)
	viscm = 0.0076					-- hệ số nhớt động học của lớp bùn (m^2/s)
	ursell = 10.0					-- ngưỡng trên số Ursell (cao hơn, không tính QUAD)
	qb = 1.0						-- ngưỡng tỉ lệ các con sóng vỡ 
end

-- Phương pháp số (PROP, NUM)
mxitst = 30						-- số bước lặp tối đa khi tính sóng "tĩnh tại"
alfa = 0.00						-- hằng số tỉ lệ; tăng để đạt ổn định số trị 
dabs = 0.005					-- chỉ tiêu sai số tuyệt đối 
drel = 0.01						-- chỉ tiêu sai số tương đối  
curvat = 0.005					-- chỉ tiêu sai số độ cong đường lặp 
npts = 99.0						-- % số các điểm thoả mãn yêu cầu 

-- Quy ước khác (SET) (mặc định)
do 
	nor = 90						-- góc tạo bởi hướng Bắc với trục x, chiều ngược KĐH
	depmin = 0.05					-- độ sâu tối thiểu phục vụ tính toán
	maxmes = 200					-- số thông báo lỗi tối đa 
	maxerr = 1						-- mức lỗi cho phép chạy chương trình 
	grav = 9.81						-- gia tốc trọng trường (m/s^2)
	rho = 1025						-- mật độ nước biển (kg/m^3)
	cdcap = 2.5E-3					-- giới hạn trên của hệ số cản gió 
	inrhog = 0						-- năng lượng theo m^2/s (0) hay W/m^2 (1) ?
	hsrerr = 0.10					-- sai số tương đối về Hs tại biên 
	NAUTICALorCARTESIAN = 'NAUTICAL'-- quy định hướng sóng,gió theo hải văn hay Đềcác?
	pwtail = 4						-- số mũ đuôi cao tần của phổ (4 hoặc 5)
	froudmax = 0.8					-- số Froude (=U/sqrt(gh)) tối đa 
	printf = 4						-- mã số file PRINT (4). Cho = 6 sẽ in ra màn hình.
	prtest = 6						-- mã số file TEST (4). Cho = 6 sẽ in ra màn hình. 
end 

-- Kết quả (POINTS, CURVE, GROUP, SPECOUT, TABLE, BLOCK)
xypointlist = '600000 2100000  600200 2100200'	-- danh sách một vài điểm xuất k.quả phổ. Toạ độ x y.
xp1 = 600450.						-- toạ độ x của điểm đầu đoạn xuất số liệu 
yp1 = 2100200.						-- toạ độ y của điểm đầu đoạn xuất số liệu 
nseg = 20						-- số khoảng chia đoạn xuất số liệu 
xpN = 600000.						-- toạ độ x của điểm cuối đoạn xuất số liệu
ypN = 2100200.						-- toạ độ y của điểm cuối đoạn xuất số liệu
SPEC1DorSPEC2D = 'SPEC2D'		-- k.quả phổ 1 chiều hay 2 chiều?
ix1 = 1 							-- STT nhỏ nhất ô lưới trục x để xuất trường kết quả 
ix2 = mxc						-- STT lớn nhất ô lưới trục x để xuất trường kết quả 
iy1 = 1							-- STT nhỏ nhất ô lưới trục y để xuất trường kết quả 
iy2 = myc						-- STT lớn nhất ô lưới trục y để xuất trường kết quả 
extraparam = ''					-- những thông số đăng ký thêm để xuất số liệu 

------ Kết thúc phần sửa số liệu ------

swaninp_template = [[
   PROJECT  'Hau Loc'  'Test'  'Swan simulation'
            'Research Project'
            'Wave Propagation Across Mangrove Forest'

   SET  LEVEL  %(level).2f   
   SET  NOR %(nor).0f  %(NAUTICALorCARTESIAN)s                                  
   SET  DEPMIN %(depmin).2f  MAXMES %(maxmes)i   MAXERR %(maxerr)i  GRAV %(grav).2f  RHO %(rho).0f CDCAP %(cdcap)f 			 
   SET  INRHOG %(inrhog)i  HSRERR %(hsrerr).2f  PWTAIL %(pwtail)i                              
   SET  FROUDMAX %(froudmax).1f  PRINTF %(printf)i  PRTEST %(prtest)i 

   MODE  STATIONARY TWOD 
   
$   COORD  CART
   
   CGRID  REGULAR %(xpc).1f  %(ypc).1f  %(alpc).1f  %(xlenc).1f %(ylenc).1f %(mxc)i %(myc)i CIRCLE %(mdc)i  %(flow).2f  %(fhig).2f  %(msc)i

   INPGRID BOT REG %(xpinp).1f  %(ypinp).1f  %(alpinp).1f  %(mxinp)i %(myinp)i  %(dxinp).1f %(dyinp).1f

   READINP BOT -1 '%(filebot)s' 2 0 

   WIND  %(wvel).1f %(wdir).1f 

%(optJONSWAP)s   BOUND SHAPE JONSWAP  %(gamma).1f  %(PEAKorMEAN)s   DSPR  %(POWERorDEGREE)s
%(optPM)s   BOUND SHAPE PM  %(PEAKorMEAN)s   DSPR  %(POWERorDEGREE)s
   
%(optBOUND1)s   BOUNDSPEC SIDE  %(bndside1)s CCW CONST PAR	%(hs1).2f  %(per1).1f  %(dir1).0f  %(dd1).0f
%(optBOUND2)s   BOUNDSPEC SIDE  %(bndside2)s CCW CONST PAR  %(hs2).2f  %(per2).1f  %(dir2).0f  %(dd2).0f
%(optBOUND3)s   BOUNDSPEC SIDE  %(bndside3)s CCW CONST PAR  %(hs3).2f  %(per3).1f  %(dir3).0f  %(dd3).0f
  
%(optINITDEF)s   INIT DEFAULT 
%(optINITPAR)s   INIT PAR  %(hs).2f %(per).1f  90.  %(dd).0f
   
%(optGEN3JANSSEN)s   GEN3 JANSSEN  %(cds1).1f %(delta).1f
%(optGEN3KOMEN)s   GEN3 KOMEN %(cds2)f %(stpm)f  %(AGROWorNOT)s %(a)f 

   WCAP KOMEN %(cds2)f %(stpm)f %(powst).1f %(delta).1f %(powk).1f 

   QUADRUPLET %(iquad)i %(lambda).2f %(cnl4)f %(csh1)f %(csh2)f %(csh3)f

%(optBREAKCONST)s   BREAK CONST %(alpha).1f %(gammab).2f 
%(optBREAKRUESSINK)s   BREAK RUESSINK %(alpha).1f  %(aruessink).2f %(bruessink).2f   
%(optBREAKBKD)s   BREAK BKD %(alpha).1f %(gamma0).2f %(a1).2f %(a2).2f %(a3).2f 

%(optFRICJONSWAP)s   FRIC JONSWAP CONST %(cfjon).3f
%(optFRICCOLLINS)s   FRIC COLLINS %(cfw).3f
%(optFRICMADSEN)s   FRIC MADSEN %(kn).2f
%(optFRICRIPPLE)s   FRIC RIPPLE %(s).2f %(D)f

   TRIAD %(itriad)i %(trfac).1f %(cutfr).1f %(atriad).2f %(btriad).2f 
    
%(optVEGE)s   VEGE  %(height).1f %(diamtr).2f %(nstems)i %(drag).2f
%(optTURB)s   TURB  %(ctb).2f %(CURRENTorNOT)s %(tbcur)f
%(optMUD)s   MUD  %(layer).1f  %(rhom)4.0f  %(viscm)f
%(optLIM)s   LIM %(ursell).1f %(qb).1f

%(optSETUP)s   SETUP %(supcor).2f

%(optOFFWINDGR)s   OFF WINDGR 
%(optOFFQUAD)s   OFF QUAD
%(optOFFWCAP)s   OFF WCAP
%(optOFFBREAK)s   OFF BREAK
%(optOFFFSHIFT)s   OFF FSHIFT 
%(optOFFBNDCHK)s   OFF BNDCHK
$
   PROP BSBT

   NUM  STOPC  %(dabs).3f  %(drel).2f  %(curvat).3f  %(npts).2f  STAT  %(mxitst)i  %(alfa).2f

   POINTS  'diem'  %(xypointlist)s    
   CURVE  'doan'  %(xp1).1f  %(yp1).1f  %(nseg)i  %(xpN).1f  %(ypN).1f
   GROUP 'mien'  SUBGRID %(ix1)i  %(ix2)i  %(iy1)i  %(iy2)i
   
   
$  OUTPUT OPTION  '%'  (TABle [field])  (SPEC  [ndec])
   
   SPECOUT   'diem'  %(SPEC1DorSPEC2D)s  ABS  '%(filespecout)s'
   TABLE  'doan' HEAD   '%(filetableout)s'  XP  HSIGN  DIR  PER  DEPTH  WATLEV  GENWIND  DISSIP & 
   		DISBOT  DISSURF  WLEN  SETUP  %(extraparam)s
   BLOCK  'mien' HEAD  '%(fileblockout)s'  HS  DIR  PER  DEPTH
   
$
   TEST 1,0
   COMPUTE  
   STOP
]]
do 
	-- Xử lý số liệu 
	-- Loại trừ 
	optPM = not optJONSWAP
	optINIT_PAR = not optINIT_DEF
end

-- Thêm dấu chú thích vào những cái không chọn 

if optJONSWAP then optJONSWAP = '' else optJONSWAP = '$' end 
if optPM then optPM = '' else optPM = '$' end 
if optINITDEF then optINITDEF = '' else optINITDEF = '$' end 
if optINITPAR then optINITPAR = '' else optINITPAR = '$' end 
if optBOUND1 then optBOUND1 = '' else optBOUND1 = '$' end 
if optBOUND2 then optBOUND2 = '' else optBOUND2 = '$' end 
if optBOUND3 then optBOUND3 = '' else optBOUND3 = '$' end 
if optGEN3JANSSEN then optGEN3JANSSEN = '' else optGEN3JANSSEN = '$' end 
if optGEN3KOMEN then optGEN3KOMEN = '' else optGEN3KOMEN = '$' end 
if optBREAKCONST then optBREAKCONST = '' else optBREAKCONST = '$' end 
if optBREAKRUESSINK then optBREAKRUESSINK = '' else optBREAKRUESSINK = '$' end 
if optBREAKBKD then optBREAKBKD = '' else optBREAKBKD = '$' end 
if optFRICJONSWAP then optFRICJONSWAP = '' else optFRICJONSWAP = '$' end 
if optFRICCOLLINS then optFRICCOLLINS = '' else optFRICCOLLINS = '$' end 
if optFRICMADSEN then optFRICMADSEN = '' else optFRICMADSEN = '$' end 
if optFRICRIPPLE then optFRICRIPPLE = '' else optFRICRIPPLE = '$' end 
if optVEGE then optVEGE = '' else optVEGE = '$' end 
if optTURB then optTURB = '' else optTURB = '$' end 
if optMUD then optMUD = '' else optMUD = '$' end 
if optLIM then optLIM = '' else optLIM = '$' end 
if optSETUP then optSETUP = '' else optSETUP = '$' end 
if optOFFWINDGR then optOFFWINDGR = '' else optOFFWINDGR = '$' end 
if optOFFQUAD then optOFFQUAD = '' else optOFFQUAD = '$' end 
if optOFFWCAP then optOFFWCAP = '' else optOFFWCAP = '$' end 
if optOFFBREAK then optOFFBREAK = '' else optOFFBREAK = '$' end 
if optOFFFSHIFT then optOFFFSHIFT = '' else optOFFFSHIFT = '$' end 
if optOFFBNDCHK then optOFFBNDCHK = '' else optOFFBNDCHK = '$' end 
 
-- Lập nội dung file swn 
-- Using RiciLake's solution for string interpolation 
-- source: http://lua-users.org/wiki/StringInterpolation
function interp(s, tab)
  return (s:gsub('%%%((%a%w*)%)([-0-9%.]*[cdeEfgGiouxXsq])',
            function(k, fmt) return tab[k] and ("%"..fmt):format(tab[k]) or
                '%('..k..')'..fmt end))
end
getmetatable("").__mod = interp
-- End RiciLake code 

str = swaninp_template % {
	fileswn=fileswn, filebot=filebot, filespecout=filespecout, filetableout=filetableout,
	xpinp=xpinp, mxinp=mxinp, dxinp=dxinp, ypinp=ypinp, myinp=myinp, dyinp=dyinp, alpinp=alpinp, 
	xpc=xpc, xlenc=xlenc, ypc=ypc, ylenc=ylenc, alpc=alpc, mxc=mxc, myc=myc, mdc=mdc, flow=flow, fhig=fhig, msc=msc,
	optJONSWAP=optJONSWAP, optPM=optPM, gamma=gamma, 
	PEAKorMEAN=PEAKorMEAN, POWERorDEGREE=POWERorDEGREE, 
	optBOUND1=optBOUND1, bndside1=bndside1, hs1=hs1, per1=per1, dir1=dir1, dd1=dd1,
	optBOUND2=optBOUND2, bndside2=bndside2, hs2=hs2, per2=per2, dir2=dir2, dd2=dd2,
	optBOUND3=optBOUND3, bndside3=bndside3, hs3=hs3, per3=per3, dir3=dir3, dd3=dd3,
	optINITDEF=optINITDEF, optINITPAR=optINITPAR, hs=hs, per=per, dir=dir, dd=dd,
	level=level, wvel=wvel, wdir=wdir, 
	optOFFWINDGR=optOFFWINDGR, optOFFWCAP=optOFFWCAP, optOFFBREAK=optOFFBREAK, 
	optOFFQUAD=optOFFQUAD, optOFFFSHIFT=optOFFFSHIFT, optOFFBNDCHK=optOFFBNDCHK,
	optGEN3KOMEN=optGEN3KOMEN, optGEN3JANSSEN=optGEN3JANSSEN, 
	cds1=cds1, delta=delta, cds2=cds2, stpm=stpm, AGROWorNOT=AGROWorNOT, a=a, powst=powst, powk=powk,
	optFRICJONSWAP=optFRICJONSWAP, optFRICCOLLINS=optFRICCOLLINS,
	optFRICMADSEN=optFRICMADSEN, optFRICRIPPLE=optFRICRIPPLE, 
	cfjon=cfjon, cfw=cfw, kn=kn, s=s, D=D,
	optBREAKCONST=optBREAKCONST, optBREAKRUESSINK=optBREAKRUESSINK, 
	optBREAKBKD=optBREAKBKD, alpha=alpha, gammab=gammab, 
	aruessink=aruessink, bruessink=bruessink, gamma0=gamma0, a1=a1, a2=a2, a3=a3, 
	iquad=iquad, lambda=lambda, cnl4=cnl4, csh1=csh1, csh2=csh2, csh3=csh3,
	itriad=itriad, trfac=trfac, cutfr=cutfr, atriad=atriad, btriad=btriad, urcrit=urcrit, urslim=urslim, 
	optSETUP=optSETUP, supcor=supcor, 
	optVEGE=optVEGE, optTURB=optTURB, optMUD=optMUD, optLIM=optLIM, 
	height=height, diamtr=diamtr, nstems=nstems, drag=drag, ctb=ctb, 
	CURRENTorNOT=CURRENTorNOT, tbcur=tbcur, layer=layer, rhom=rhom, viscm=viscm, ursell=ursell, qb=qb,
	dabs=dabs, drel=drel, curvat=curvat, npts=npts, mxitst=mxitst, alfa=alfa,
	nor=nor, depmin=depmin, maxmes=maxmes, maxerr=maxerr, grav=grav, rho=rho, cdcap=cdcap,
	inrhog=inrhog, hsrerr=hsrerr, NAUTICALorCARTESIAN=NAUTICALorCARTESIAN, pwtail=pwtail, froudmax=froudmax, printf=printf, prtest=prtest,
	xypointlist=xypointlist, xp1=xp1, yp1=yp1, nseg=nseg, xpN=xpN, ypN=ypN,
	ix1=ix1, ix2=ix2, iy1=iy1, iy2=iy2, fileblockout=fileblockout,
	SPEC1DorSPEC2D=SPEC1DorSPEC2D, extraparam=extraparam,
	}

f = io.open(fileswn .. '.swn', 'w')
for line in str:gmatch("[^\r\n]+") do 
	if not string.match(line, "^$.*") then 
		f:write(line .. '\n')
	end
end
f:close()

os.execute('swanrun.bat ' .. fileswn)